Package org.kie.internal.runtime.conf

## Interface DeploymentDescriptor

- All Known Implementing Classes:
    `DeploymentDescriptorImpl`

      public interface DeploymentDescriptor

  Deployment descriptor defines configurable components of deployable unit - kjar that will be used upon deployment to execution environment providing flexible and independent setup per deployment unit

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static java.lang.String` | `META_INF_LOCATION` |
    `static java.lang.String` | `TYPE_ALL` |
    `static java.lang.String` | `TYPE_EXECUTE` |
    `static java.lang.String` | `TYPE_VIEW` |

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `AuditMode` | `getAuditMode()` | Returns the audit type configuration
    `java.lang.String` | `getAuditPersistenceUnit()` | Returns name of the JPA persistence unit to be used by audit component non empty should correspond to defined persistence unit in persistence.xml null to use default persistence unit
    `DeploymentDescriptorBuilder` | `getBuilder()` | Returns implementation specific builder to construct instances of the descriptor;
    `java.util.List<java.lang.String>` | `getClasses()` | Returns additional classes that shall be added to remote services context.
    `java.util.List<NamedObjectModel>` | `getConfiguration()` | List of kiesession configuration entries to be registered
    `java.util.List<NamedObjectModel>` | `getEnvironmentEntries()` | List of (kie) environment entries to be registered
    `java.util.List<ObjectModel>` | `getEventListeners()` | Returns list of event listeners (process, agenda, rule runtime) to be applied on `KieSession`
    `java.util.List<NamedObjectModel>` | `getGlobals()` | Return list of globals to be applied on `KieSession`
    `java.lang.Boolean` | `getLimitSerializationClasses()` | Returns whether or not the classes used in the serialization mechanism are limited to classes annotated with @`Remotable`, @`XmlRootElement`, or @`XmlType`.
    `java.util.List<ObjectModel>` | `getMarshallingStrategies()` | Returns list of object marshaling strategies to be applied on `KieSession`
    `PersistenceMode` | `getPersistenceMode()` | Returns the runtime engine persistence type configuration
    `java.lang.String` | `getPersistenceUnit()` | Returns name of the JPA persistence unit to be used for runtime engine non empty should correspond to defined persistence unit in persistence.xml null to use default persistence unit
    `java.util.List<java.lang.String>` | `getRequiredRoles()` | Returns all required roles required to be granted access to the deployment.
    `java.util.List<java.lang.String>` | `getRequiredRoles​(java.lang.String type)` | Returns required for given type of applicability.
    `RuntimeStrategy` | `getRuntimeStrategy()` | Returns runtime strategy to be used, default Singleton.
    `java.util.List<ObjectModel>` | `getTaskEventListeners()` | Returns list of task event listeners to be applied on `KieSession`
    `java.util.List<NamedObjectModel>` | `getWorkItemHandlers()` | Return list of work item handlers to be applied on `KieSession`
    `java.lang.String` | `toXml()` | Returns XML representation of this descriptor instance

- - ### Field Detail

    - #### META_INF_LOCATION

          static final java.lang.String META_INF_LOCATION

      See Also:
        Constant Field Values

    - #### TYPE_ALL

          static final java.lang.String TYPE_ALL

      See Also:
        Constant Field Values

    - #### TYPE_VIEW

          static final java.lang.String TYPE_VIEW

      See Also:
        Constant Field Values

    - #### TYPE_EXECUTE

          static final java.lang.String TYPE_EXECUTE

      See Also:
        Constant Field Values

  - ### Method Detail

    - #### getPersistenceUnit

          java.lang.String getPersistenceUnit()

      Returns name of the JPA persistence unit to be used for runtime engine
      - non empty should correspond to defined persistence unit in persistence.xml
      - null to use default persistence unit
      Returns:
        non empty string should correspond to defined persistence unit in persistence.xml, in case null is returned persistence will use default one - org.jbpm.domain

    - #### getAuditPersistenceUnit

          java.lang.String getAuditPersistenceUnit()

      Returns name of the JPA persistence unit to be used by audit component
      - non empty should correspond to defined persistence unit in persistence.xml
      - null to use default persistence unit
      Returns:
        non empty string should correspond to defined persistence unit in persistence.xml, in case null is returned persistence will use default one - org.jbpm.domain

    - #### getAuditMode

          AuditMode getAuditMode()

      Returns the audit type configuration
      Returns:

    - #### getPersistenceMode

          PersistenceMode getPersistenceMode()

      Returns the runtime engine persistence type configuration
      Returns:

    - #### getRuntimeStrategy

          RuntimeStrategy getRuntimeStrategy()

      Returns runtime strategy to be used, default Singleton.
      Returns:

    - #### getMarshallingStrategies

          java.util.List<ObjectModel> getMarshallingStrategies()

      Returns list of object marshaling strategies to be applied on `KieSession`
      Returns:

    - #### getEventListeners

          java.util.List<ObjectModel> getEventListeners()

      Returns list of event listeners (process, agenda, rule runtime) to be applied on `KieSession`
      Returns:

    - #### getGlobals

          java.util.List<NamedObjectModel> getGlobals()

      Return list of globals to be applied on `KieSession`
      Returns:

    - #### getWorkItemHandlers

          java.util.List<NamedObjectModel> getWorkItemHandlers()

      Return list of work item handlers to be applied on `KieSession`
      Returns:

    - #### getTaskEventListeners

          java.util.List<ObjectModel> getTaskEventListeners()

      Returns list of task event listeners to be applied on `KieSession`
      Returns:

    - #### getEnvironmentEntries

          java.util.List<NamedObjectModel> getEnvironmentEntries()

      List of (kie) environment entries to be registered
      Returns:

    - #### getConfiguration

          java.util.List<NamedObjectModel> getConfiguration()

      List of kiesession configuration entries to be registered
      Returns:

    - #### getBuilder

          DeploymentDescriptorBuilder getBuilder()

      Returns implementation specific builder to construct instances of the descriptor;
      Returns:

    - #### getRequiredRoles

          java.util.List<java.lang.String> getRequiredRoles()

      Returns all required roles required to be granted access to the deployment. Empty list or null means no security will be applied.
      Returns:

    - #### getRequiredRoles

          java.util.List<java.lang.String> getRequiredRoles​(java.lang.String type)

      Returns required for given type of applicability. Supported types are:
      - all
      - view
      - execute
      Parameters:
        `type` - indicates the type which required roles shoud apply
      Returns:

    - #### getClasses

          java.util.List<java.lang.String> getClasses()

      Returns additional classes that shall be added to remote services context. All classes that directly belong to kjar (or are declared as dependency of type kjar) do not need to be listed as part of this collection.
      Returns:

    - #### getLimitSerializationClasses

          java.lang.Boolean getLimitSerializationClasses()

      Returns whether or not the classes used in the serialization mechanism are limited to classes annotated with @`Remotable`, @`XmlRootElement`, or @`XmlType`. In the 6.x branches, the default is false (classes are not limited.) In the 7.x branches, the default is true (classes are limited.)
      Returns:
        a `Boolean`

    - #### toXml

          java.lang.String toXml()

      Returns XML representation of this descriptor instance
      Returns: